#ifndef _H_94DF57E4C1309EDF9F2864C09897001F_TexturedMarkerArray_DCPS_H_
#define _H_94DF57E4C1309EDF9F2864C09897001F_TexturedMarkerArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TexturedMarkerArray_.h"


namespace marti_visualization_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TexturedMarkerArray_TypeSupportInterface;

            typedef TexturedMarkerArray_TypeSupportInterface * TexturedMarkerArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TexturedMarkerArray_TypeSupportInterface> TexturedMarkerArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TexturedMarkerArray_TypeSupportInterface> TexturedMarkerArray_TypeSupportInterface_out;


            class TexturedMarkerArray_DataWriter;

            typedef TexturedMarkerArray_DataWriter * TexturedMarkerArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TexturedMarkerArray_DataWriter> TexturedMarkerArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < TexturedMarkerArray_DataWriter> TexturedMarkerArray_DataWriter_out;


            class TexturedMarkerArray_DataReader;

            typedef TexturedMarkerArray_DataReader * TexturedMarkerArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TexturedMarkerArray_DataReader> TexturedMarkerArray_DataReader_var;
            typedef DDS_DCPSInterface_out < TexturedMarkerArray_DataReader> TexturedMarkerArray_DataReader_out;


            class TexturedMarkerArray_DataReaderView;

            typedef TexturedMarkerArray_DataReaderView * TexturedMarkerArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TexturedMarkerArray_DataReaderView> TexturedMarkerArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TexturedMarkerArray_DataReaderView> TexturedMarkerArray_DataReaderView_out;

            struct TexturedMarkerArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TexturedMarkerArray_, struct TexturedMarkerArray_Seq_uniq_> TexturedMarkerArray_Seq;
            typedef DDS_DCPSSequence_var < TexturedMarkerArray_Seq> TexturedMarkerArray_Seq_var;
            typedef DDS_DCPSSequence_out < TexturedMarkerArray_Seq> TexturedMarkerArray_Seq_out;

            class  TexturedMarkerArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TexturedMarkerArray_TypeSupportInterface_ptr _ptr_type;
                typedef TexturedMarkerArray_TypeSupportInterface_var _var_type;

                static TexturedMarkerArray_TypeSupportInterface_ptr _duplicate (TexturedMarkerArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TexturedMarkerArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TexturedMarkerArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TexturedMarkerArray_TypeSupportInterface () {};
                ~TexturedMarkerArray_TypeSupportInterface () {};
            private:
                TexturedMarkerArray_TypeSupportInterface (const TexturedMarkerArray_TypeSupportInterface &);
                TexturedMarkerArray_TypeSupportInterface & operator = (const TexturedMarkerArray_TypeSupportInterface &);
            };

            class  TexturedMarkerArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TexturedMarkerArray_DataWriter_ptr _ptr_type;
                typedef TexturedMarkerArray_DataWriter_var _var_type;

                static TexturedMarkerArray_DataWriter_ptr _duplicate (TexturedMarkerArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TexturedMarkerArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TexturedMarkerArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TexturedMarkerArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TexturedMarkerArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TexturedMarkerArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TexturedMarkerArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TexturedMarkerArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TexturedMarkerArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TexturedMarkerArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TexturedMarkerArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TexturedMarkerArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TexturedMarkerArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TexturedMarkerArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TexturedMarkerArray_& instance_data) = 0;

            protected:
                TexturedMarkerArray_DataWriter () {};
                ~TexturedMarkerArray_DataWriter () {};
            private:
                TexturedMarkerArray_DataWriter (const TexturedMarkerArray_DataWriter &);
                TexturedMarkerArray_DataWriter & operator = (const TexturedMarkerArray_DataWriter &);
            };

            class  TexturedMarkerArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TexturedMarkerArray_DataReader_ptr _ptr_type;
                typedef TexturedMarkerArray_DataReader_var _var_type;

                static TexturedMarkerArray_DataReader_ptr _duplicate (TexturedMarkerArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TexturedMarkerArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TexturedMarkerArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TexturedMarkerArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TexturedMarkerArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TexturedMarkerArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TexturedMarkerArray_& instance) = 0;

            protected:
                TexturedMarkerArray_DataReader () {};
                ~TexturedMarkerArray_DataReader () {};
            private:
                TexturedMarkerArray_DataReader (const TexturedMarkerArray_DataReader &);
                TexturedMarkerArray_DataReader & operator = (const TexturedMarkerArray_DataReader &);
            };

            class  TexturedMarkerArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TexturedMarkerArray_DataReaderView_ptr _ptr_type;
                typedef TexturedMarkerArray_DataReaderView_var _var_type;

                static TexturedMarkerArray_DataReaderView_ptr _duplicate (TexturedMarkerArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TexturedMarkerArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TexturedMarkerArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TexturedMarkerArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TexturedMarkerArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TexturedMarkerArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TexturedMarkerArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TexturedMarkerArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TexturedMarkerArray_& instance) = 0;

            protected:
                TexturedMarkerArray_DataReaderView () {};
                ~TexturedMarkerArray_DataReaderView () {};
            private:
                TexturedMarkerArray_DataReaderView (const TexturedMarkerArray_DataReaderView &);
                TexturedMarkerArray_DataReaderView & operator = (const TexturedMarkerArray_DataReaderView &);
            };
        }

    }

}

#endif
